/*
 ******************************************************************************
 *
 * @file     VOX_Module.c
 * @brief    VOL/R module
 *                 
 *
 * @version  1.0
 * @date     2022/07/18   09:59:40
 * @author   Alex Xu
 *
 * Copyright (c) 2013-2099,Tkplusemi Technology Co.,Ltd.
 * All Rights Reserved
 *
 * History:
 * Revision          Date           Author            Desc
 * 1.0.0            2022/07/18      Alex          build this file
 ******************************************************************************
 */
#include "vox_module.h"
#include "led.h"
#include "system.h"
#include "discharge_module.h"
#include "sleep.h"
#include "bat.h"
#include "hall.h"
#include "key.h"
#include "sys_tim.h"
#include "adc.h"
#include "gpio_comm.h"
#include "userapp.h"

bit Vox_Vout_Enable = OFF;						//Vox־λ
bit Earphone_Chg_Flag = 0;						//б־λ
uint8_t Vox_TX_Timer = 0;						//VOXָʱ,Hall_Handler0.

#if VOX_ENABLE

/******************************************************************************\
                          Macro definitions
\******************************************************************************/
/*100ms*/
#define VOX_OUTPUT_SHORT_CNT		2
#define VOX_LOW_BAT_CNT				25					//ظǰӵ͵籣Vox 5V2.5s  	
#define VOX_VOUT_5V_LEAST_CNT		200	

#define VOX_VOUT_5V_DEBOUNCE		3					//ǰӵѹ3.582VVOX 5V150ms
#define VOX_ADT_HOLD_CNT			3
#define Vox_TX_Pattern_Cnt			3
#define VOX_IOFF_HOLD_CNT			30

#define BOOST_VOUT_MAX				2					//Boostѹֵ0:4.6V,1:4.7V,2:4.8V,3:5.05V.
/******************************************************************************\
                             Variables definitions
\******************************************************************************/


uint8_t Vox_Vol_Hold_Timer = 0;

bit Cover_Close_Flag = 0;
bit Cover_Close_Flag1 = 0;

bit Cover_Open_Flag = 0;
bit Vox_Vout_5V_Flag = 0;

uint8_t Vox_Output_Short_Debounce = 0;

bit Get_CHIP_STA1_Flag = 0;

bit Pattern_TX_Over_Flag = 0;

uint8_t CHIP_STA1_BK = 0;
bit Vox_None_Inbox_Flag = 0;

#if VOX_FOLLOW_CHG

bit Vor_In_Box_Flag = 0;
bit Vol_In_Box_Flag = 0;

bit Boost_VoxVout_Follow_Flag = 0;
int8 Boost_Vout_Value = 0;
bit Boost_Up_Flag = 0;

#endif


/******************************************************************************\
                             Functions definitions
\******************************************************************************/

/*
  *******************************************************************************
  * 			void VOX_EN_Type(VOR_Enable_Type_e VOR_Enable_Type)
  *
  * Description : VOL Open(EN_VO)

  * Arguments	:
 
  * Returns 	:
 
  * Notes		:
  *
  *******************************************************************************
  */
 void VOX_EN_Type(VOX_Enable_Mode_e VOX_Enable_Mode)
 { 
 	COM_CTRL = ON;

	if( VOX_Enable_Mode == VOX_VOUT_Mode)
	{
		VOX_CTL0 &= ~0x30;		//VOX Disable 5V And Disable VOX ADT
		
		VOX_CTL0 |= 0x30;		//VOX Enable 5V    
	}
	else
	{
		VOX_CTL0 &= ~0x30;    //VOX 5v Off 	
	}
}
/*
*******************************************************************************
*			 void Vox_Det_Machine(void)
*
* Description : Vox Detect:ʶ (100ms)
*
* Arguments	 : NONE

* Returns	 : NONE

* Notes		 : NONE
*
*******************************************************************************
*/
void Vox_Det_Machine(void)
{
	/*Vox ֻÿ200msһ*/
	if( IRQ_FLAG0 & 0x0C )
	{		
		Vox_Output_Short_Debounce++;
		if( Vox_Output_Short_Debounce >= VOX_OUTPUT_SHORT_CNT )		//Vox·200ms¿Vox 5V
		{
			Vox_Output_Short_Debounce = 0;
			IRQ_FLAG0 = 0x0C;
			VOX_EN_Type(VOX_VOUT_Mode);	
			return;
		}
	}	

	if( CoverEvent_Flg )								//Hall¼
	{	
		if( gBoost_Prepared_Flag )
		{				
			COM_CTRL = ON;
					
			if( CoverStatus == CLOSE )    				//1ظǹرCOM_CTRLʾЧѯLoadonIOFF״̬۶Ƿڲ֣Vox 5V
			{
				Cover_Close_Flag = 1;

				Cover_Close_Flag1 = 1;
								
				CoverEvent_Flg = 0;		
				
				Vox_Vout_Enable = ON;
				
				Cover_Open_Flag = 0;
				
				Vol_In_Box_Flag = 0;
				Vor_In_Box_Flag = 0;

			//	Vox_Vol_Hold_Timer = 0;					//ظ0ʹ
				
				VOX_EN_Type(VOX_ADT_Mode);
			//	P10 = 1;
			//	P03 = 0;
				//return;
			}
			else										//2ǴVoxѹpattern tx ѭ3Ρ
			{			
				Cover_Close_Flag = 0;
			
				if( Vox_Vout_Enable == OFF )				//ǰӵص͵磬򿪸ǺVOX 5V300ms
				{			
					BST_EN = 1; 

					VOX_CTL0 |= 0x30;		//VOX
					
					if( Vox_Vol_Hold_Timer < VOX_VOUT_5V_DEBOUNCE )			
					{
						Vox_Vol_Hold_Timer++;
						
						return;
					}
					
					VOX_CTL0 &= ~0x30;    //VOX 5v Off 
					
					BST_EN = 0;
				}

				COM_CTRL = OFF;
				
				PATTERN_TX = ON;
				
				Vox_Vol_Hold_Timer = 0;
				
				Cover_Open_Flag = 1;

				//Get_CHIP_STA1_Flag = 0;

				CoverEvent_Flg = 0;		

				Pattern_TX_Data = ( (bat_level*10) << 8) | FW_VER2;			//ȡӵ汾								
			}		
		} 
		else
		{			
			VOX_EN_Type(VOX_ADT_Mode);
		}
	}

	/* Ϳָ*/
	if( Cover_Open_Flag )													/*ǺVbat(Adtģʽ)300ms󣬷pattern*/
	{
		if( Vox_Vol_Hold_Timer < VOX_ADT_HOLD_CNT )			
		{
			Vox_Vol_Hold_Timer++;
			
			return;
		}
		
		if( Vox_TX_Timer < Vox_TX_Pattern_Cnt )
		{
			BST_EN = 1;

			PATTERN_TX = OFF;
			
			VOX_CTL0 |= 0x30;												//VOXMOS
			
			Pattern_TX_Start = 1;
			
			Vox_TX_Timer++;

			Pattern_TX_Over_Flag = 1;

			COM_CTRL = ON;
		}
		else
		{
			if( Pattern_TX_Over_Flag )
			{
				Pattern_TX_Over_Flag = 0; 
				
				VOX_EN_Type(VOX_ADT_Mode);  								//ȹVOX 5VٹBoost
				
				BST_EN = 0;		
				
				COM_CTRL = ON;

				PATTERN_TX = ON;
				
				Vox_Vout_Enable = OFF;
				
			}
			else
			{
				if( !Get_CHIP_STA1_Flag )
				{
					Get_CHIP_STA1_Flag = 1;
					
					CHIP_STA1_BK = CHIP_STA1 & 0xA0;			//ȡloadon״̬
				}
			}
			
			if( Get_CHIP_STA1_Flag )
			{
				/*ж*/
				if( CHIP_STA1_BK != (CHIP_STA1 & 0xA0) )		//ѯloadon״̬loadon״̬ı䣬˵жС
				{
					Earphone_Chg_Flag = 1;	

					LED_On_Timer = 0;
					
					CHIP_STA1_BK = CHIP_STA1 & 0xA0;
				}
			}
		}
	}
	
	if( Cover_Close_Flag )
	{		
		if( Cover_Close_Flag1 )
		{
			if( !Get_CHIP_STA1_Flag )		  //ظǺжмֻں
			{
				Get_CHIP_STA1_Flag = 1;

				if( CHIP_STA1 & 0xA0 )
				{
					if( (CHIP_STA1 & 0xA0) == 0x80 )		 //VOR
					{
						Vor_In_Box_Flag = 1;
					}
					else
					if( (CHIP_STA1 & 0xA0) == 0x20 )		//VOL
					{
						Vol_In_Box_Flag = 1;
					}
					else						//ڡ
					{
						Vor_In_Box_Flag = 1;
						Vol_In_Box_Flag = 1;
					}
				}
				else
				{
					Vox_None_Inbox_Flag = 1;
				}
				
			}
				
			if( !BST_EN )
			{		
		#if VOX_FOLLOW_CHG
				/*߼*/

				SFRADDR = OTP_KEY;
				SFRDATA = 0x69;
				
				SFRADDR = BST_CTL0;									//Boost 5V
				SFRDATA |= 0x03;
				
				SFRADDR = OTP_KEY;
				SFRDATA = 0x01;	
					
				Boost_Vout_Value = 0x03;
				Boost_Up_Flag = 0;
				
				SFRADDR = VOX_CON0;									//IOFFѡߵ10/15/20/25mA
				SFRDATA |= 0x20;	

				SFRADDR = VOX_CON2;									 
				SFRDATA &= ~0xC0;
				SFRDATA |= 0x80;									//IOFF 20mA
			
				Boost_VoxVout_Follow_Flag = 1;

		#endif
				BST_EN = 1; 							//Boost Enable쳣ʱӲرաBoostVox 5vڿBoost֮100msʱ 
		//		P10 = 1;
				return;
			}	
			
			//	P10 = 0;
			
			if( Vor_In_Box_Flag && Vol_In_Box_Flag )
			{
				VOX_CTL0 |= 0x30; 
			}		
			else
			if( Vol_In_Box_Flag )		//VOL
			{
				VOX_CTL0 |= 0x10; 	//VOL Enable 5V  
			}
			else						//ڡ
			if( Vor_In_Box_Flag )		 //VOR
			{
				VOX_CTL0 |= 0x20;	//VOR Enable 5V  
			}
			else
			{
				Boost_VoxVout_Follow_Flag = 0;
			}
			
			if( Vox_Vol_Hold_Timer < VOX_IOFF_HOLD_CNT )			//ȶ硣
			{
				Vox_Vol_Hold_Timer++;
				
				return;
			}	
			
			Cover_Close_Flag1 = 0;
		}
		else
		{	
		#if VOX_FOLLOW_CHG
		
			if( Boost_VoxVout_Follow_Flag )
			{
				if ( CHIP_STA1 & 0x0C )					//ǷIOFF־ڣBoostһstepBoost½һstep
				{
					Boost_Vout_Value += 1;								//Boost һstep
				
					Boost_Up_Flag = 1;
				
					if( Boost_Vout_Value >= BOOST_VOUT_MAX )				//Boostﵽѹֵ䡣
					{
						Boost_Vout_Value = BOOST_VOUT_MAX;
						
						Boost_VoxVout_Follow_Flag = 0;
						
						SFRADDR = VOX_CON0;									//IOFFѡ͵2/3/4/5mA
						SFRDATA &= ~0x20;	

						SFRADDR = VOX_CON2;									 
						SFRDATA &= ~0xC0;
						SFRDATA |= 0x40;									//IOFF 3mA			
					}	
					
				}
				else
				{
					if( !Boost_Up_Flag )						//ֻڳʼصѹʱִ
					{
						Boost_Vout_Value -= 1;								//Boost ½һstep
						if( Boost_Vout_Value <= 0 )
						{
							Boost_Vout_Value = 0;
						}
					}
				}
				
				SFRADDR = OTP_KEY;
				SFRDATA = 0x69;	
				
				SFRADDR = BST_CTL0; 								//Boost 
				SFRDATA &= ~0x03;
				SFRDATA |= Boost_Vout_Value;
				
				SFRADDR = OTP_KEY;
				SFRDATA = 0x01; 

				return;
			}

			
		#endif
		}

		if( Vor_In_Box_Flag && Vol_In_Box_Flag )
		{
			if( (CHIP_STA1 & 0xAC) == 0xAC )
			{
				Vox_None_Inbox_Flag = 1;
				Vor_In_Box_Flag = 0;
				Vol_In_Box_Flag = 0;
			}
		}		
		else
		if( Vol_In_Box_Flag )		//VOL
		{
			if( (CHIP_STA1 & 0x24) == 0x24 )
			{
				Vox_None_Inbox_Flag = 1;
				Vol_In_Box_Flag = 0;
			}
		}
		else						//ڡ
		if( Vor_In_Box_Flag )		 //VOR
		{
			if( (CHIP_STA1 & 0x88) == 0x88 )
			{
				Vox_None_Inbox_Flag = 1;
				Vor_In_Box_Flag =0;
			}
		}
		
	//	if( ( (CHIP_STA1 & 0xAC) == 0xAC ) || F_batlevel_protect || Vox_None_Inbox_Flag )				//ӵ͵磬VOXҪ5V0VرVoutͨ·رBoost
		if( F_batlevel_protect || Vox_None_Inbox_Flag )
		{	
			if ( F_batlevel_protect )		//ظǰӵ͵磬ظʱΪVoxADTתΪ5V2.5s
			{
				if( Vox_TX_Timer < VOX_LOW_BAT_CNT )
				{
					Vox_TX_Timer++;
					
					return;
				}
			}
			else
			{
				if( Vox_TX_Timer < VOX_VOUT_5V_LEAST_CNT )
				{
					Vox_TX_Timer++;
					
					return;
				}
			}
			
			VOX_CTL0 &= ~0x30;    //VOX 5v Off عʹ		ȹVOX 5V ٹBoost
			
			BST_EN = 0; 
								
			COM_CTRL = OFF;
			
			Vox_Vout_Enable = OFF;
					
			gBoost_Prepared_Flag = 0;

			PATTERN_TX = OFF;
		}
	}	
}


#endif

